Agent set abstraction
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "agentSetAbstraction",
"abstraction": {}
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "agentSetAbstraction",
"abstraction": {}
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {type: 'agentSetAbstraction', abstraction: {}},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
agentSetAbstraction | Hyperliquid exchange
Sets the account abstraction configuration on behalf of the user via an approved agent. Chainstack Hyperliquid exchange reference.
POST
/
exchange
Agent set abstraction
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"agentSetAbstraction"abstraction(object) — Abstraction configuration
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "agentSetAbstraction"},
"nonce": 1234567890123,
"signature": {...}
}'
from eth_account import Account
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
# Agent wallet approved to act on behalf of the user
agent = Account.from_key("AGENT_PRIVATE_KEY")
exchange = Exchange(agent, constants.MAINNET_API_URL)
# abstraction is one of "u" (unifiedAccount), "p" (portfolioMargin), "i" (disabled)
result = exchange.agent_set_abstraction("u")
print(result)
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
// Agent wallet approved to act on behalf of the user
const wallet = privateKeyToAccount("0x...");
const transport = new HttpTransport(); // default public Hyperliquid API
const exchange = new ExchangeClient({ transport, wallet });
// abstraction is one of "u" (unifiedAccount), "p" (portfolioMargin), "i" (disabled)
const result = await exchange.agentSetAbstraction({ abstraction: "u" });
console.log(result);
Use case
- Agent set abstraction — Sets the account abstraction configuration on behalf of the user via an approved agent.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?